import java.util.*;
import java.lang.*;
import java.io.*;
/**
   player question
   das ist das entscheidende organ. hier entscheidet sich was fr ein wert der spieler hat.
   steht er auf dem feld und sieht er den ball.

   @author marcus,jochen
   @version 0.07

*/

public class PlayerQuestion extends Thread
{
    private LinkedList jetzt = new LinkedList();
    public WorldModel weltmodell;
    public int Spielmodus;
    private WorldModelElement Element, Ball;
    private int next_to_ball;

    final private double epsilon = 0.5;
    public double homeposx;
    public double homeposy;

    private FieldObject BallPos;
    private Object Element_obj;
    private double ballx,bally,kuerzeste_balldist, kuerzeste_feinddist, testabstand;

    //  private int i

    //, t1, t2; // woher und wann weiss ich, wann welche Liste aktuell bzw alt ist?
    // werden da einfach die Zeiger umgesetzt?

    public PlayerQuestion(WorldModel weltmodell_uebergabe,double homeposx_uebergabe, double homeposy_uebergabe)
    {
    	this.homeposx = homeposx_uebergabe;
    	this.homeposy = homeposy_uebergabe;
    	weltmodell = weltmodell_uebergabe;

    }

  




    /**
     * gibt zurck, ob sich der Spieler
     * auf dem Spielfeld befindet (koordinaten sind bekannt)
     */
    private boolean steh_ich_auf_feld_koordinate(double ichx, double ichy)
    {
	if (ichx >= 52 || ichx <= -52)
	    {
		return false;
	    }
	else
	    {
		if (ichy >= 31.5 || ichy <= -31.5)
		    {
			return false;
		    }
		else
		    {
			return true;
		    }
	    }


    }


    /**
     * -1 bei "seh ich nicht"
     * den Ball als Element der t0 liste bei "seh ich"
     */
  public WorldModelElement seh_ich_ball()
  {

	  jetzt = weltmodell.getT0();
    for (int i=1; i <= jetzt.size()-1; i++)
	    {
        Element = (WorldModelElement)jetzt.get(i);  // DAS IST EIN CAST!!
        	if (Element.isFriend == 2)
		      {
    			return Element;
		      }
	    }
  	return null;
  }

    /**
     * -1 bei "seh ich nicht"
     * den Ball als Element der t0 liste bei "seh ich"
     * @param liste Liste, in der ich nach dem Ball suche
     */
  public WorldModelElement seh_ich_ball(LinkedList jetzt)
  {


	  for (int i=1; i <= jetzt.size()-1; i++)
	    {
        Element = (WorldModelElement)jetzt.get(i);  // DAS IST EIN CAST!!
        	if (Element.isFriend == 2)
		      {
    			return Element;
		      }
	    }
  	return null;
  }

    /*
     * selbsterklrend...
     * gibt winkel zurck
     */
    public double berechne_richtung_Koordinate(double ax, double ay, double bx, double by)
    {// 100 % validiert !!

	double winkel = Math.abs(Math.toDegrees(Math.atan(Math.abs((ay-by)/(ax-bx)))));
	//System.out.println("berechne_richtung_Koordinate: " + (int)ax + "/"+(int)ay+ " zu " +(int)bx + "/"+(int)by + " macht: " + winkel);

	if ((ax -bx) < 0)
	    {
		if ((ay - by) < 0)
		    {
			//System.out.println("berechne_richtung_Koordinate 1: " + (int)ax + "/"+(int)ay+ " zu " +(int)bx + "/"+(int)by + " macht: " + (int)winkel + "returns: " + (int)winkel);
			return winkel;
		    }
		else
		    {
			//System.out.println("berechne_richtung_Koordinate 2: " + (int)ax + "/"+(int)ay+ " zu " +(int)bx + "/"+(int)by + " macht: " + (int)winkel + "returns: " + (int)(-1*winkel));
			return(-1*winkel);
		    }
	    }
	else
	    {
		if ((ay - by) < 0)
		    {
			//System.out.println("berechne_richtung_Koordinate 3: " + (int)ax + "/"+(int)ay+ " zu " +(int)bx + "/"+(int)by + " macht: " + (int)winkel + "returns: " + (int)(180-winkel));
			return (180-winkel);
		    }
		else
		    {
			//System.out.println("berechne_richtung_Koordinate 4: " + (int)ax + "/"+(int)ay+ " zu " +(int)bx + "/"+(int)by + " macht: " + (int)winkel + "returns: " + (int)(-180+winkel));
			return (-180 + winkel);

		    }
	    }

    }



    public double berechne_richtung_WML(WorldModelElement a, WorldModelElement b)
    {
	return berechne_richtung_Koordinate(a.x, a.y, b.x, b.y);
    }


    public boolean hinter_homepos(double ichx, double homeposx)
    {
	if ((ichx- homeposx) < epsilon)// vielleicht en anderes epsilon whlen...
	    {
		return true;
	    }
	else
	    {
		return false;
	    }
    }
    /*
     *
     * checkt, wer aus der aktuellen jetzt-liste am nchsten zum Ball steht
     * -1 fr gegner hat ball
     * (0 fr unident hat ball) // kommt vielleicht noch
     * 1 fr ich hab ball
     * 2 fr kamerad hat ball
     */
    public int check_next_to_ball(WorldModelElement Ball)
    {
	jetzt = weltmodell.getT0();


	kuerzeste_balldist = Ball.dist;
	next_to_ball = 1; //mal frech davon ausgehend, dass ich den Ball hab

	for (int i = 1; i<= jetzt.size()-1;i++) // i = 1 weil "0" bin ich ja selber
	    {
		Element = (WorldModelElement)jetzt.get(i);
		if (Element.isFriend!=2)
		    {
			if (AbstandWML(Element, Ball) < kuerzeste_balldist)
			    {
				kuerzeste_balldist = AbstandWML(Element, Ball);
				if (Element.isFriend == 0)
				    {
					next_to_ball = 2;
				    }
				else
				    {
					next_to_ball = -1;
				    }
			    }
		    }
	    }

	return next_to_ball;
    }

    /*
     *
     * checkt, wer aus der aktuellen jetzt-liste am nchsten zum Ball steht
     * -1 fr gegner hat ball
     * (0 fr unident hat ball) // kommt vielleicht noch
     * 1 fr ich hab ball
     * 2 fr kamerad hat ball
     */

  public int check_next_to_pos(double ax,double ay, int toleranz)
  {
	jetzt = weltmodell.getT0();
	kuerzeste_balldist = Abstand_ich_Koordinate(ax,ay, this.get_ich_jetzt(jetzt))- toleranz;
  double testabstand = 0;
	next_to_ball = 1;
	for (int i = 1; i <= jetzt.size()-1 ;i++)
	{
		Element = (WorldModelElement)jetzt.get(i);
		if (Element.isFriend!=2)
		{
      testabstand = AbstandKoordinate(Element.x, Element.y, ax, ay);
			if (testabstand < kuerzeste_balldist )
			{
				kuerzeste_balldist = testabstand;
				if (Element.isFriend == 0)
				{
					next_to_ball = 2;
				}
				else
				{// bei unident oder wirklich gegner
					next_to_ball = -1;
				}
		  }
  	}
	}
	return next_to_ball;
  }

  public FieldObject check_next_to_pos_FO(double ax,double ay, double toleranz)
  {
	jetzt = weltmodell.getT0();
	kuerzeste_balldist = Abstand_ich_Koordinate(ax,ay, this.get_ich_jetzt(jetzt))- toleranz;
  double testabstand = 100;
  	FieldObject temp = new FieldObject();
    temp.wer = 1;
    temp.jetzt_entfernung = kuerzeste_balldist;

	for (int i = 1; i <= jetzt.size()-1 ;i++)
	{
		Element = (WorldModelElement)jetzt.get(i);
		if (Element.isFriend!=2)
		{
      testabstand = AbstandKoordinate(Element.x, Element.y, ax, ay);
			if (testabstand < kuerzeste_balldist )
			{
				kuerzeste_balldist = testabstand;
				if (Element.isFriend == 0)
				{
					temp.wer = 2;
        }
				else
				{// bei unident oder wirklich gegner
          temp.wer = -1;
        }
        temp.jetzt_x = Element.x;
        temp.jetzt_y = Element.y;
        temp.jetzt_entfernung = kuerzeste_balldist;
		  }
  	}
	}
	return temp;
  }
    /*
     *berechnet den Abstand zweier WorldModelElement objekte
     *
     */
    public double AbstandWML(WorldModelElement a, WorldModelElement b)
    {
	return AbstandKoordinate(a.x, a.y, b.x, b.y);
    }

    /*
     * berechnet den Abstand zweier Punkte, deren Koordinaten bekannt sind
     *
     */
    public double AbstandKoordinate(double ax, double ay, double bx, double by)
    {
	return Math.sqrt((ax - bx)*(ax - bx)+(ay - by)*(ay - by));
    }


    /*
     * berechnet den Abstand vo mir zu nem Punkt, dessen Koordinaten bekannt sind
     *
     */
    public double Abstand_ich_Koordinate(double zielx, double ziely)
    {
      Element = this.get_ich_jetzt();
      return Math.sqrt((Element.x - zielx)*(Element.x - zielx)+(Element.y - ziely)*(Element.y - ziely));
    }

    public double Abstand_ich_Koordinate(double zielx, double ziely, WorldModelElement ich)
    {
      Element = ich;
      return Math.sqrt((Element.x - zielx)*(Element.x - zielx)+(Element.y - ziely)*(Element.y - ziely));
    }



    public boolean nah_genug_fuer_torschuss(double ichx, double ichy, double max_entfernung_zum_tor)
    {
        if (AbstandKoordinate(ichx, ichy, 52.5, 0) < max_entfernung_zum_tor)
	    {
		return true;
	    }
        else
	    {
		return false;
	    }
    }





    public boolean ist_gegner_in_naehe(int umkreis, double ichx, double ichy)
    {

	jetzt = weltmodell.getT0();

	kuerzeste_feinddist = 1000;


	for (int i=1; i <= jetzt.size()-1; i++)
	    {

		Element = (WorldModelElement)jetzt.get(i);

		if (Element.isFriend == 1)
		    {
			testabstand = AbstandKoordinate(ichx, ichy, Element.x, Element.y);
			if (testabstand < kuerzeste_feinddist)
			    {
				kuerzeste_feinddist = testabstand;
			    }
		    }

	    }
	if (kuerzeste_feinddist < umkreis)
	    {
		return true;
	    }
	else
	    {
		return false;
	    }
    }




    public boolean steht_gegner_im_weg(double winkel)
    {
	jetzt = weltmodell.getT0();

	boolean temp =false;

	for (int i=1; i <= jetzt.size()-1; i++)
	    {
		Element = (WorldModelElement)jetzt.get(i);
		if (Element.isFriend == 1)
		    {

			if (Element.dir< 0)
			    {
				if (Element.dir < -winkel)
				    {
					return true;

				    }
			    }
			else
			    {
				if (Element.dir < winkel)
				    {
					return true;
				    }
			    }

		    }
	    }
    return false;
    }




  public LinkedList wait_for_new_WM(LinkedList momentan)
  {
	  LinkedList temp;
  	do
	    {
	    	temp = this.weltmodell.getT0();
    		try { sleep(10); }
    		catch (Exception e) {}
	    }
  	while (temp==momentan);
	  return temp;
  }

    /* gibt zurck, wie arg ich vom Kurs abgekommen bin
     * (nur positive winkel)
     * @ param winkela mein Winkel
     * @ param winkelb da, wo ich hin soll
     * @ return differenz der beiden Winkel
     */
    public double gradabweichung(double winkela, double winkelb)
    {
	double differenz = Math.abs((winkela - winkelb));
	if (differenz > 180)
	    {
		return (360 - differenz);

	    }
	else
	    {
		return differenz;

	    }
    }

    public boolean bin_ich_auf_kurs(double ziel, double toleranz)
    {
	WorldModelElement ich_jetzt = this.get_ich_jetzt();

	if (gradabweichung(ich_jetzt.dir, ziel) < toleranz)
	    {
		return true;
	    }
	else
	    {
		return false;
	    }
    }
      
   /**
    * gibt das mich-Objekt zurck
    */
    public WorldModelElement get_ich_jetzt()
    {
  	  jetzt= this.weltmodell.getT0();
    	return (WorldModelElement)jetzt.getFirst();
    }

    public WorldModelElement get_ich_jetzt(LinkedList jetzt)
    {
    WorldModelElement ergebnis = null;
      {
    		try
        {
          ergebnis = (WorldModelElement)jetzt.getFirst();
        }
		    catch (Exception e) {}
	    }

      return ergebnis;
    }

   /**
    * gibt das Ball-Objekt zurck, wenn der BAll nicht gefunden werden kann, wird suche_ball ausgelst
    */
    public WorldModelElement get_ball_jetzt()
    {
      jetzt= this.weltmodell.getT0();
      if (jetzt.size() < 2) {return null;}
      for (int i = 1; i<= jetzt.size()-1;i++)
      {
        Element = (WorldModelElement)jetzt.get(i);
    		if (Element.isFriend==2)
        {
        return Element;
        }
      }

  	return null;
    }

   /**
    * gibt das Ball-Objekt zurck, wenn der BAll nicht gefunden werden kann, wird suche_ball ausgelst
    */
    public WorldModelElement get_ball_jetzt(LinkedList jetzt)
    {

      if (jetzt.size() < 1)
      {
      return null;
      }
      else
      {
        for (int i = 1; i<= jetzt.size()-1;i++)
        {
          Element = (WorldModelElement)jetzt.get(i);
      		if (Element.isFriend==2)
          {
            return Element;
          }
        }
      }
  	return null;
    }





    public boolean bin_ich_in_feindhaelfte(double ichx)
    {

      if (ichx == Double.NaN)
      {
      System.out.println("+++OHJE! ich bin vermutlich in der Feindhlfte!");
      return true; //vorsichtshalber

      }
      else
      {
        if(ichx > 0)
        {
        return true;
        }
        else
        {
        return false;
        }
      }
    }




     /**
     * gibt Position, wo Spieler evtl. hinrennen wird.
     * keine toleranz, da eine ueberprufung/korrektur hierbei sinnlos ist.
     * @param wen Wem wollen wir vorhalten?
     * @return Position, oder { NaN,NaN }
     */

    public double[] wohin_rennt_spieler(WorldModelElement wen)
    {
	LinkedList alt=weltmodell.getT1();
	String name=wen.name;
	WorldModelElement Element;
	//koente timing-probs geben....
	for (int i=1; i <= alt.size()-1; i++) 
	    {
		Element = (WorldModelElement)alt.get(i);
		if (Element.name.equals(wen.name))
		    {
			double[] rueckgabe={ 2.0*wen.x-Element.x, 2.0*wen.y-Element.y };
			return rueckgabe;
		    }
	    }
	double[] rueckgabe={ Double.NaN, Double.NaN };
	return rueckgabe;
    }

    /**
     * gibt Pos. wo Ball evtl. hinrollen wird im naechsten Zyklus,
     * sofern er speed und richtung nicht verndert
     * @return Pos, wo Ball sein wird, oder { NaN, NaN }
     */

    public double[] wohin_rollt_ball()
    {
	WorldModelElement ballNeu=seh_ich_ball();
	WorldModelElement ballAlt=seh_ich_ball(weltmodell.getT1());
	double[] rueckgabe={ Double.NaN, Double.NaN };
	int alter=1;

	//falls ich keinen Ball sehe, den jetzt-Stand des Balls zurckgeben
	if (ballNeu==null)
	{

		return rueckgabe;
  }

	//aber, wenn das alte keinen hat, werd nur "ungenauer"
	if (ballAlt==null)
	    {
		ballAlt=seh_ich_ball(weltmodell.getT2());
		//jetzt aber Pech...
		if (ballAlt==null)
		    {
			return rueckgabe;
		    }
		alter=2;
	    }


	  if (alter==1)
	    {
		rueckgabe[0]=ballNeu.x+(0.8*(ballNeu.x-ballAlt.x));
		rueckgabe[1]=ballNeu.y+(0.8*(ballNeu.y-ballAlt.y));
	    } else {
		rueckgabe[0]=ballNeu.x+(0.444*(ballNeu.x-ballAlt.x));
		rueckgabe[1]=ballNeu.y+(0.444*(ballNeu.y-ballAlt.y));
	    }

  rueckgabe[0] = ballNeu.x;
  rueckgabe[1] = ballNeu.y;
	return rueckgabe;
  
  }
    /**
     * gibt Pos. wo Ball evtl. hinrollen wird im bestimmten Zyklus,
     * sofern er speed und richtung nicht verndert
     * @param timeadv fuer wieviele Zyklen weit weg soll es berechnet werden.
     * @return Pos, wo Ball sein wird, oder { NaN, NaN }
     */

    public double[] wohin_rollt_ball(int timeadv)
    {
	WorldModelElement ballNeu=seh_ich_ball();
	WorldModelElement ballAlt=seh_ich_ball(weltmodell.getT1());
	double[] rueckgabe={ Double.NaN, Double.NaN };
	int alter=1;

	//falls ich keinen Ball sehe... Pech?
	if (ballNeu==null)
	    {
		    return rueckgabe;
	    }

	//aber, wenn das alte keinen hat, werd nur "ungenauer"
	if (ballAlt==null)
	    {
		ballAlt=seh_ich_ball(weltmodell.getT2());
		//jetzt aber Pech...
		if (ballAlt==null)
		    {
			return rueckgabe;
		    }
		alter=2;
	    }

	double factor=0.8;
	double factor_org=factor;
	
	for (int i=1; i<=timeadv; i++)
	    {
		factor*=factor_org;
	    }
	

	if (alter==1)
	    {
		rueckgabe[0]=ballNeu.x+(factor*timeadv*(ballNeu.x-ballAlt.x));
		rueckgabe[1]=ballNeu.y+(factor*timeadv*(ballNeu.y-ballAlt.y));
	    } else {
		rueckgabe[0]=ballNeu.x+(factor*timeadv/2.0*(ballNeu.x-ballAlt.x));
		rueckgabe[1]=ballNeu.y+(factor*timeadv/2.0*(ballNeu.y-ballAlt.y));
	    }
	return rueckgabe;
    }


    public FieldObject wohin_rollt_ballFO()
    {
	WorldModelElement ballNeu=seh_ich_ball();
	WorldModelElement ballAlt=seh_ich_ball(weltmodell.getT1());
	FieldObject rueckgabe= new FieldObject();
	int alter=1;

	//falls ich keinen Ball sehe... Pech?
	if (ballNeu==null)
	    {
		    return rueckgabe;
	    }
  else
      {
        rueckgabe.jetzt_x = ballNeu.x;
        rueckgabe.jetzt_y = ballNeu.y;
        rueckgabe.jetzt_entfernung = ballNeu.dist;
        rueckgabe.Ball_jetzt = ballNeu;
      }
	//wenn der alte Ball unbek ist, dann pech
	if (ballAlt==null)
  {
		ballAlt=seh_ich_ball(weltmodell.getT2());
		//jetzt aber Pech..., weil auch der ganz alte ball nicht bekannt is
		if (ballAlt==null)
    {
			return rueckgabe;
    }
    else
    {
      rueckgabe.spaeter_x = ballAlt.x;
      rueckgabe.spaeter_y = ballAlt.y;
      rueckgabe.spaeter_entfernung = ballAlt.dist;
    }
		alter=2;
  }
  else
  {
    rueckgabe.spaeter_x = ballAlt.x;
    rueckgabe.spaeter_y = ballAlt.y;
    rueckgabe.spaeter_entfernung = ballAlt.dist;
  }


  	  if (alter==1)
	    {
		rueckgabe.spaeter_x=ballNeu.x+(0.8*(ballNeu.x-ballAlt.x));
		rueckgabe.spaeter_y=ballNeu.y+(0.8*(ballNeu.y-ballAlt.y));
	    } else {
		rueckgabe.spaeter_x=ballNeu.x+(0.444*(ballNeu.x-ballAlt.x));
		rueckgabe.spaeter_y=ballNeu.y+(0.444*(ballNeu.y-ballAlt.y));
	    }


    return rueckgabe;
    }




  /**
   * Auskopplung aus turn relative, berechnet nur den drehwinkel, ohne sich dann echt zu drehen
   *
   *
   */
  public double berechne_drehwinkel(double ziel, WorldModelElement ich_jetzt)
  {
        double meine_dir = ich_jetzt.dir;
        double drehwinkel = 0;

        if (meine_dir < 0)
            {
                if (ziel < 0)
                    {
                        if (meine_dir < ziel)
                            {
                                //turn_absolute(-1*(meine_dir-ziel));
                                drehwinkel = (-1*(meine_dir-ziel));
                            }
                        else
                            {
                                drehwinkel=(ziel-meine_dir);
                                //turn_absolute(ziel-meine_dir);//ok!
                                //System.out.println("turn rel 2, ich guck nach: " + (int)meine_dir + ", ziel = " + (int)ziel + " drehen um: " + (int)(ziel-meine_dir));
                            }

                    }
                else
                    {
                        drehwinkel = (ziel-meine_dir);
                        //System.out.println("turn rel 3, ich guck nach: " + (int)meine_dir + ", ziel = " + (int)ziel + " drehen um: " + (int)(ziel-meine_dir));
                    }
            }
        else
            {//meine dir > 0
                if (ziel < 0)
                    {
                        drehwinkel= (ziel-meine_dir);
                        //turn_absolute(ziel-meine_dir);
                        //System.out.println("turn rel 4, ich guck nach: " + (int)meine_di
                    }
                else   //ich und ziel grer 0
                    {
                        if (meine_dir < ziel)
                            {
                                drehwinkel= (ziel-meine_dir);
                                //turn_absolute(ziel-meine_dir);//ok!
                                //System.out.println("turn rel 5, ich guck nach: " + (int)meine_dir + ", ziel = " + (int)ziel + " drehen um: " + (int)(ziel-meine_dir));
                            }
                        else
                            {
                                drehwinkel = (-1*(meine_dir-ziel));
                                //turn_absolute(-1*(meine_dir-ziel)); // ok!
                                //System.out.println("turn rel 6, ich guck nach: " + (int)meine_dir + ", ziel = " + (int)ziel + " drehen um: " + (int)(-1*(meine_dir-ziel)));
                            }
                    }
            }

        if (Math.abs(drehwinkel) > 180)
            {
                if (drehwinkel < 0)
                    {
                        drehwinkel = 360 + drehwinkel;
                    }
                else
                    {
                        drehwinkel = drehwinkel-360;
                    }

            }

        return drehwinkel;
    }//methodenende


  public boolean steht_einer_im_abseits(LinkedList jetzt)
  {
    // ist ein ball in der liste enthalten?
    WorldModelElement ball_jetzt = this.get_ball_jetzt(jetzt);

    if (ball_jetzt == null){return false;}// dann mal einfach false zurckgeben, das wrd sonst das spiel nur unntig behindern


    for (int i = 1; i <= jetzt.size()-1 ;i++)
	  {
		  Element = (WorldModelElement)jetzt.get(i);
  		if (Element.isFriend!=0)
	  	{
      	if (Element.x > ball_jetzt.x){return true;}


  		}
  	}
    return false;
  }

  public void set_spielmodus(int modus)
  {
    this.Spielmodus = modus;
  }


  public FieldObject suche_anspielstation()
  {
    LinkedList jetzt = this.weltmodell.getT0();
    double kuerzeste_dist = 1000;
    FieldObject rueckgabe = null;

    if (jetzt.size() != 0)
    {
      for (int i = 1; i <= jetzt.size()-1 ;i++)
	    {
		    Element = (WorldModelElement)jetzt.get(i);
  		  if (Element.isFriend!=0)
  	  	{
        	if (Element.dist < kuerzeste_dist)
          {
            kuerzeste_dist = Element.dist;
            rueckgabe.Ball_jetzt = Element;

          }
        }
    	}
    }
  return rueckgabe;
  }


}// klassenende
