//doc fertig

import javax.swing.*;// braucht man bei GUI auf jeden Fall
import java.awt.*; // braucht man bei GUI auf jeden Fall
import java.io.*; // wird wieder rausgenommen, nur zum berprfen der zwischenwerte
import java.util.*; // fr die linkedlist des weltmodells und random()

/**  visualisation_field.java      Stand: 25.06.02
 *   visualisation_field ist ein Thread, der losluft oder anhlt, sobald im GUI
 *   entsprechende Knpfchen gedrckt werden (anzeigen, bzw. stoppen-Button).
 *
 *    @author: Esther Krug, Marcus Mandel
 *    @version: $Id: Visualisation_field_draw.java,v 1.5 2002/07/14 09:56:43 hco Exp $
 *    @see: visualisation.java, WorldModel.java, WorldModelElement.java
 */

public class Visualisation_field_draw extends JPanel implements Runnable
{
  // im konstruktor einmal alle gifs laden, dann jeweils nur noch anzeigen
  // denn paint sollte weniger speicher und rechenzeit fressen,
  // als wie wenn das ding jedesmal neu geladen wird.


  // variablen fr bunte sachen
/**
 *  Der Media Tracker "sammelt" die ganzen Bilder und erzeugt sie dann
 *  gemeinsam, also nicht Stck fr Stck (??? wissen wir selbst nicht so genau)
 *  dadurch geht das zeichnen aber schneller
 */
  private MediaTracker my_mediaTracker;
/**
 *  Das Spielfeld, das als Hintergund dient, ein roter Punkt, ein blauer Punkt,
 *  ein Punkt fr "unidentified_running_objects" - wenn man nicht wei, ob
 *  freund oder feind, einen Ball, zu_zeichnen dient der paint() als "Variable",
 *  die das jeweils zu zeichnende Objekt aufnimmt
 */
  private Image  legende, spielfeld, Punkt_rot, Punkt_blau, Punkt_uro, Ball, Punkt_gelb, zu_zeichnen;
/**
 *  Toolkit ist ne Zeichenhilfe glaub ich. Wir wissen aber leider nicht wozu
 *  genau die gut sein soll, blderweise funktionierts ohne aber nicht.
 */
  private Toolkit toolkit;
/**
 *  wird derzeit nur fr die Implementierung des T0-ersatzes gebraucht, wird
 *  bentigt, um festzustellen, ob der ausgewhlte Spieler den Ball berhaupt sieht
 */
  private boolean ball_gemalt = false;
/**
 *  braucht man auch nur vorbergehend (?), fliegt wohl wieder raus, wenn die
 *  t0-Liste ok ist
 */
  private Font schrift = new Font("Arial", Font.BOLD, 16);
/**
 *  braucht man auch nur vorbergehend (?), fliegt wohl wieder raus, wenn die
 *  t0-Liste ok ist
 */
  private Color farbe;

  //variablen fr syntax

/**
 *  my_thread ist der Thread der den GUI der Visu immer wieder zeichnen soll
 */
  private Thread my_thread = null;
/**
 * wird von Visualisation bergeben, damit die visualisation_field weiss, wessen
 * Weltbild sie zu malen hat.
 */
  private int ausgewaehlter_spieler = 0;
/**
 *  braucht man, um das Wuschkriterium der bunten Schrift zu erreichen
 */
  private Random ran = new Random();
/**
 *  muss ich dazu was sagen? ich finde, das ist deikes sache. wir brauchen es
 *  aber, um die to-Liste importeiren zu knnen (fr den CAST)
 */
  private WorldModel weltbild;
/**
 * das spielerarray dient zur bergabe der Spieler an visu_field
 * so kann jeder Spieler gezeichhnet werden, da alle Weltbilder zugreifbar sind.
 */
  private Player[] spielerarray;
/**
 *  muss ich dazu was sagen? ich finde, das ist deikes sache. Wir brauchen die
 *  "jetzt"-Liste (t0), um die Punkte entsprechend der darin angegebenen Daten
 *  (WML Element) zu zeichnen
 */
  private LinkedList jetzt;
/**
 *  siehe "jetzt"
 */
  private WorldModelElement Element;

  // diese variablen sind nur zum testen; kommen wieder raus
  private int zufallx, zufally;
  private int zaehler;
  private int xpos_ball, ypos_ball;


  private Player ausgewaehlter_player;

/*
 * Konstruktor halt, gibt's nix zu sagen, oder ?
 */
  public Visualisation_field_draw(Player[] alle_spieler)
  {
  spielerarray = alle_spieler;
  // init ist besser, weil so ein Runnable-Thread das irgendwie bevorzugt
  }




/**
 *    init() ldt alle Bilder (init() tut all das, was initialisert werden muss,
 *    bevor das Thread-Interface gestartet wird )
 *    @return: offensichtlich nichts
 *    @exception: InterruptedException im MediaTracker
 */
  public void init()
  { // konstruktor anfang
    System.out.println("visu field init()");
    my_mediaTracker = new MediaTracker(this);// einen media tracker machen
    toolkit = getToolkit();

    spielfeld = toolkit.getImage("spielfeld.gif");
    my_mediaTracker.addImage(spielfeld, 0);

    Punkt_rot = toolkit.getImage("punkt_rot.gif");
    my_mediaTracker.addImage(Punkt_rot, 0);

    Punkt_blau = toolkit.getImage("punkt_blau.gif");
    my_mediaTracker.addImage(Punkt_blau, 0);

    Punkt_uro = toolkit.getImage("punkt_uro.gif");
    my_mediaTracker.addImage(Punkt_uro, 0);

    Punkt_gelb = toolkit.getImage("punkt_gelb.gif");
    my_mediaTracker.addImage(Punkt_gelb, 0);

    legende = toolkit.getImage("legende.gif");
    my_mediaTracker.addImage(legende, 0);

    Ball = toolkit.getImage("ball.gif");
    my_mediaTracker.addImage(Ball, 0);


      try
      {
  		my_mediaTracker.waitForAll();
      }
      catch(InterruptedException e)
      {
   		System.out.println("MediaTracker-Exception");
    	}

   System.out.println("visu field init fertig");
  }  // init ende




/**
 *   started den Thread, der das Spielfeld immer wieder zeichnen soll
 *   @return: keiner
 *   @exception: kein Exception-Handling
 */
  public void start()
  {
   if (my_thread == null);
   {
   System.out.println("thread losgelassen");
   my_thread = new Thread(this);
   System.out.println("            my_thread = new Thread(this); ");
   my_thread.start();
   }
  }




/**
 *   hlt den Thread an
 *   @return: keiner
 *   @exception: kein Exception-Handling
 */
  public void stop()
  {
   if (my_thread != null);
   {
    System.out.println("stop!");
    my_thread.stop();
    my_thread = null;
   }
  }



/**
 *   macht den Thread "nicht ununterbrochen", sorgt aber dafr, dass er nicht so
 *   viel Speicher braucht - teilt ihm also bestimmte Zeitscheibchen zu, legt
 *   ihn gelegentlich mal auf Eis
 *
 *   @return: keiner
 *   @exception: kein Exception-Handling
 */
  public void pause(int milisek)
  {
   try { Thread.sleep(milisek); }
   catch (InterruptedException e) {}
  }


/**
 *   paint() zeichnet das, was der in der ComboBox ausgewhlte Spieler sieht,
 *   insbesondere das Spielfeld mit den darauf befindlichen objekten;
 *   wird dann fters von repaint() aufgerufen
 *   @return: keiner
 *   @exception: kein Exception-Handling
 */
  public void paint(Graphics g)
  {
  System.out.println("spielfeld paint()" + zaehler);
  zaehler ++; // temporr

  // wichtig, da sonst immer mehr und mehr punkte aufm Feld wren.
  g.drawImage(spielfeld, 0, 0, this);
  g.drawImage(legende, 0,412, this);


  // das hier fliegt dan noch raus:
  zufallx= ran.nextInt(600);
  zufally = ran.nextInt(320);
  //g.drawImage(Ball, zufallx, zufally, this);

  //g.drawImage(Ball, 303, 217, this);
  //g.drawImage(Ball, 25, 217, this);
  //g.drawImage(Punkt_rot, zaehler, zaehler, this);
  //g.drawImage(Punkt_blau, zaehler, 127, this);


    /*
     jetzt das Weltbild des betroffenen Players holen und aus
     der t0 liste die beweglichen objekte extrahieren
     je nachdem, was es fr ein Objekt ist, das Bild bestimmen und
     es dann an die Koordinaten malen
    */


    // Weltbild holen
   if (this.ausgewaehlter_spieler != 0)
   {
      //System.out.println("ausgewaehlter_spieler hab ich, ist der nummer " + this.ausgewaehlter_spieler);
      ausgewaehlter_player = spielerarray[this.ausgewaehlter_spieler];
      //System.out.println("ausgewaehlter_player zugewiesen");
      if (ausgewaehlter_player!= null)
      {
        //System.out.println("ausgewaehlter_player hab ich");
        weltbild = ausgewaehlter_player.WeltBild;
        //System.out.println("Weltbild hab ich");
        jetzt = weltbild.getT0();
        if (jetzt.size() != 0)
          {

            Element = (WorldModelElement)jetzt.getFirst();
            g.drawImage(Punkt_gelb, x_transform(Element.x), y_transform(Element.y), this);
            for (int i=1; i <= jetzt.size()-1; i++)
            {
              Element = (WorldModelElement)jetzt.get(i);
              //System.out.println("Element " + i + " der liste ist ein " +Element.isFriend);
              switch(Element.isFriend)//0=Freund 1=Feind 2=Ball 3=Unbekannt/Undef.
              {
                case 0:
                {
                  zu_zeichnen = Punkt_blau;
                  break;
                }

                case 1:
                {
                  zu_zeichnen = Punkt_rot;
                  break;
                }

                case 2:
                {
                  zu_zeichnen = Ball;
                  ball_gemalt = true;
                  break;
                }

                case 3:
                {
                  zu_zeichnen = Punkt_uro;
                  break;
                }
              }//switch ende
            g.drawImage(zu_zeichnen, x_transform(Element.x), y_transform(Element.y), this);

          }// for ende

        }//if liste.size != 0 ende
        //else
        //{System.out.println("liste ist leer!");}
      }//if player != 0 ende
      //else
     //{System.out.println("ausgewhlter player ist null");}
   }//if spieler != 0 ende
   //else
   //{System.out.println("noch kein player gewhlt");}


    // wurde der Ball nicht gefunden/gemalt, so wird dieser Text ins Feld geschrieben
    if (!ball_gemalt)
    {
    farbe = new Color(ran.nextInt(255), ran.nextInt(255), ran.nextInt(255));
    g.setColor(farbe);
    g.setFont(schrift);
    g.drawString("Wo ist nur der Ball geblieben?", ran.nextInt(9)*40, ran.nextInt(10)*30 +10);
    }
    ball_gemalt = false;
  }


/**
 * wird vom Actionlistener des anzeigen Buttons aufgerufen, damit die
 * visualisation_field den zu zeichnenden Spieler kennt.
 * @return: keiner
 * @exception: kein Exception-Handling
 */
  public void set_ausgewaehlter_spieler(int uebergabe)
    {
    this.ausgewaehlter_spieler = uebergabe;
    }



/**
 *   ruft stndig repaint() auf. repaint() ruft wiederum paint() auf,
 *   was ja berschrieben wurde, um immer die t0-Liste zu parsen und zu
 *   zeichnen.
 *
 *   @return: keiner
 *   @exception: kein Exception-Handling
 */
  public void run()
  {
    while(true)
    {
    System.out.println("repaint befehl erzwungen");
    this.repaint();
    this.pause(400);
    }
  }



/**
 *  an diesen Zahlen NIX ndern, sind so ausgetestet!!!
 *  Transformiert die x-Koordinate der Weltmodell-Darstellung in
 *  die passenden Koordinatengren.
 *
 *  @return: keiner
 *  @exception: kein Exception-Handling
 */
  private int x_transform(double alt)
  {
  return (int)(((alt+ 52.5) * 5.28)+26);
  }

 /**
 *  an diesen Zahlen NIX ndern, sind so ausgetestet!!!
 *  Transformiert die y-Koordinate der Weltmodell-Darstellung in
 *  die passenden Koordinatengren.
 *
 *  @return: keiner
 *  @exception: kein Exception-Handling
 */
 private int y_transform(double alt)
  {
  return (int)(((alt + 34)*5.32)+36);
  }

//Klassen-Ende
}


