import java.util.*;
// doc fertig

/** Der Actor gibt dem Spieler seine Fhingkeiten.Der Spieler kann dann 
 * passen, laufen, schieen und alles was er sonst noch so braucht.


 @author Jochen Reiss, Marcus Mandel, hco
 * @version 0.9

*/
public class Actor extends Thread
{
    /** reference to the communicationChannel */
    private CommunicationChannel communicationChannel;
    private PlayerQuestion my_PlayerQuestion;
    private Parser my_parser;
    // wenn man [index] weit weg is vom ball, dann wird noch mit exaktheit[index] viel power hingedasht
    private int[] exaktheit = {35,65,65,65,75,85,80,90,100,100};

    /** die aktuelle Entferung zur Homeposition */
    private double homedist, homeposx, homeposy;
    private WorldModelElement ich_jetzt, ball_jetzt;
    private LinkedList jetzt;
    private double[] ballPos={ 0,0 };
    private FieldObject BallPos;

    /**Steuert den Spieler und gibt ihm seine Fhigkeiten */
    public Actor(CommunicationChannel communicationChannel)
    {
      this.communicationChannel = communicationChannel;
    }
    /**
     * verpasst dem Actor eine PlayerQuestion, damit er Infos ber das Weltmodell holen kann.
     */
    public void add_PlayerQuestion(PlayerQuestion fragebeantworter)
    {
    	this.my_PlayerQuestion = fragebeantworter;
    	homeposx = my_PlayerQuestion.homeposx;
    	homeposy = my_PlayerQuestion.homeposy;
    }

    /**
     * verpasst dem Actor einen parser, damit er direkte Infos ber tiem und so bekommt
     */
    public void add_parser(Parser gucker)
    {
	    this.my_parser = gucker;
    }


    /**
       Melde den Spieler am Server an 
    */
    public void init(String teamName)
    {
    	communicationChannel.send(new String("(init " + teamName + "(version 7.0))"));
    }

    /**
       Melde den Torwart am Server an
    */
    public void initGoalie(String teamName)
    {
    	communicationChannel.send(new String("(init " + teamName + "(version 7.0) (goalie))"));
    }

    /**
       Rennt mit Anstrengung "power". Power zwischen 0 und 100
       @param Power 0..100
    */
    public void dash(double power)
    {
    	//System.out.println("dashen mit power = " + power);
    	communicationChannel.send(new String("(dash " + power + ")"));
    }


    /**
       Stellt Spieler an Stelle x,y nur mglich bei anspiel und direkt nach einem tor.
       @param   x,y= (-52,5..52,5 ; -34..34)
    */
    public void move(double x, double y)
    {
    	communicationChannel.send(new String("(move " + x + " " + y + ")"));
    }
	
    /**
       dreht Spieler um "angle" Grad
       @param  angle um dieen Winkel soll sich der Spieler drehen
    */
	
    public void turn_absolute(double angle)
    {
    	communicationChannel.send(new String("(turn " + angle + ")"));
    }

    /**
     * dreht den Spieler unter Bercksichtigung des eigenen Winkels so, dass er
     * den absoluten Winkel (Ziel) zur Spielfeld mitte einnimmt.
     * @param ziel da soll der Spieler hingucken
     *
     */
    public void turn_relative(double ziel)
    {
        jetzt = my_PlayerQuestion.weltmodell.getT0();
        ich_jetzt = (WorldModelElement)jetzt.getFirst();
        double meine_dir = ich_jetzt.dir;
        double drehwinkel = 0;

        if (meine_dir < 0)
            {
                if (ziel < 0)
                {
                  if (meine_dir < ziel)
                  {
                    drehwinkel = (-1*(meine_dir-ziel));
                  }
                  else
                  {
                    drehwinkel=(ziel-meine_dir);
                  }
                }
                else
                {
                  drehwinkel = (ziel-meine_dir);
                }
            }
        else
            {//meine dir > 0
                if (ziel < 0)
                {
                  drehwinkel= (ziel-meine_dir);
                }
                else   //ich und ziel grer 0
                {
                  if (meine_dir < ziel)
                  {
                    drehwinkel= (ziel-meine_dir);
                  }
                  else
                  {
                    drehwinkel = (-1*(meine_dir-ziel));
                  }
                }
            }

        if (Math.abs(drehwinkel) > 180)
            {
                if (drehwinkel < 0)
                    {
                        drehwinkel = 360 + drehwinkel;
                    }
                else
                    {
                        drehwinkel = drehwinkel-360;
                    }
	          }
        turn_absolute(drehwinkel);//ok!
        my_parser.waitForTimestamp();
        //System.out.println("turn relative mit drehwinkel " + drehwinkel);
	
    }//methodenende
    
    public void turn_relative(double ziel, WorldModelElement ich_jetzt)
    {
        double meine_dir = ich_jetzt.dir;
        double drehwinkel = 0;

        if (meine_dir < 0)
            {
                if (ziel < 0)
                    {
                        if (meine_dir < ziel)
                            {
                                //turn_absolute(-1*(meine_dir-ziel));
                                drehwinkel = (-1*(meine_dir-ziel));
                            }
                        else
                            {
                                drehwinkel=(ziel-meine_dir);
                                //turn_absolute(ziel-meine_dir);//ok!
                                //System.out.println("turn rel 2, ich guck nach: " + (int)meine_dir + ", ziel = " + (int)ziel + " drehen um: " + (int)(ziel-meine_dir));
                            }

                    }
                else
                    {
                        drehwinkel = (ziel-meine_dir);
                        //System.out.println("turn rel 3, ich guck nach: " + (int)meine_dir + ", ziel = " + (int)ziel + " drehen um: " + (int)(ziel-meine_dir));
                    }
            }
        else
            {//meine dir > 0
                if (ziel < 0)
                    {
                        drehwinkel= (ziel-meine_dir);
                        //turn_absolute(ziel-meine_dir);
                        //System.out.println("turn rel 4, ich guck nach: " + (int)meine_di
                    }
                else   //ich und ziel grer 0
                    {
                        if (meine_dir < ziel)
                            {
                                drehwinkel= (ziel-meine_dir);
                                //turn_absolute(ziel-meine_dir);//ok!
                                //System.out.println("turn rel 5, ich guck nach: " + (int)meine_dir + ", ziel = " + (int)ziel + " drehen um: " + (int)(ziel-meine_dir));
                            }
                        else
                            {
                                drehwinkel = (-1*(meine_dir-ziel));
                                //turn_absolute(-1*(meine_dir-ziel)); // ok!
                                //System.out.println("turn rel 6, ich guck nach: " + (int)meine_dir + ", ziel = " + (int)ziel + " drehen um: " + (int)(-1*(meine_dir-ziel)));
                            }
                    }
            }

        if (Math.abs(drehwinkel) > 180)
            {
                if (drehwinkel < 0)
                    {
                        drehwinkel = 360 + drehwinkel;
                    }
                else
                    {
                        drehwinkel = drehwinkel-360;
                    }

            }
        my_parser.waitForTimestamp();
        turn_absolute(drehwinkel);//ok!

        //System.out.println("turn relative mit drehwinkel " + drehwinkel);
    }//methodenende


    /**
       dreht Kopf um "angle" Grad Aktelle Blickrichtung + "Angle"
       @param  angle -180..180
    */
    public void turn_neck(double angle)
    {
	communicationChannel.send(new String("(turn_neck " + angle + ")"));
    }
	
    /**
       schiesst den Ball mit "power" in Richtung "angle"
       @param power 0..100
       @param angle -180..180
    */
    public void kick(double power, double angle)
    {
	communicationChannel.send(new String("(kick " + power + " " + angle + ")"));
    }

    /**
       bruellt die "msg" 
       @param msg Ist ein String,der von dem Spieler gerufen wird.
    */
    public void say(String msg)
    {
	communicationChannel.send(new String("(say " + msg + ")"));
    }
	
    //Bis hier waren die "wichtigsten" Kommandos
	
    /**
       forder Server auf zustzlich "Sense_body"-Infos zu schicken.
    */
    public void sense_body()
    {
	communicationChannel.send(new String("(sense_body)"));
    }

    /**
       laesst den Server den Spielstand schicken
       Darauf freut sich die hlfte aller spieler.:)
    */
    public void score()
    {
	communicationChannel.send(new String("(score)"));
    }
	

    public void change_view(int width, int quality)
	//width: 0=narrow,1=normal,2=wide
	//quality: 0=low,1=high
    {
  quality = 1;
	String wi="normal";
	String qu="low";
	if (width==0) { wi="narrow";
        } else if (width==1) { wi="normal";
        } else if (width==2) { wi="wide"; }
	if (quality==0) { qu="low";
        } else if (quality==1) { qu="high"; };
        communicationChannel.send("(change_view "+wi+" "+qu+")");
    }

    //Fuck: braucht nen anderen Namen, da catch schon belegt ist
	
    /**
       Der Torwart fngt den Ball. der aus der richtung angle kommt
       @param angle -180..180
    */
    public void catch_it(double angle)
    {
	communicationChannel.send(new String("(catch " + angle + ")"));
    }

    /**
     * lsst den Spieler in einer Schleife zur angegebenen Koordinate laufen
     * @param zielx die x koordinate des Zielpunkts
     * @param ziely die y koordinate des Zielpunkts
     * @param intense so schnell luft der spieler da hin
     * @param abstand wenn er so nah am Ziel ist, hrt er auf
     */

    public void lauf_zu_position(double zielx, double ziely, int intense, double abstand)
    {
        double abstand_test = 0;
        double abstand_test_last = 1000;

        jetzt = my_PlayerQuestion.weltmodell.getT0();
        ich_jetzt = (WorldModelElement)jetzt.getFirst();

        schau_nach_ziel(my_PlayerQuestion.berechne_richtung_Koordinate(ich_jetzt.x, ich_jetzt.y, zielx, ziely), 8);

        dash(intense);
        //try { sleep(50); }
        //catch (Exception e) {};

        do
	    {


                jetzt = my_PlayerQuestion.weltmodell.getT0();
                ich_jetzt = (WorldModelElement)jetzt.getFirst();

                if (!my_PlayerQuestion.bin_ich_auf_kurs(my_PlayerQuestion.berechne_richtung_Koordinate(ich_jetzt.x, ich_jetzt.y, zielx, ziely), 2))
                    {
                        schau_nach_ziel(my_PlayerQuestion.berechne_richtung_Koordinate(ich_jetzt.x, ich_jetzt.y, zielx, ziely), 3);

                    }

                // jetzt berprfen ob wir noch auf Kurs sind
                abstand_test = my_PlayerQuestion.AbstandKoordinate(ich_jetzt.x, ich_jetzt.y, zielx, ziely);
                /*  if (Double.isNaN(abstand_test))
                    {
                    abstand_test = 1000;
                    }
                    else
                    {
                    if (abstand_test > abstand_test_last)
                    {
                    System.out.println("       ***** AH bin auf krassen Irrweg!! ****      ");
                    schau_nach_ziel(my_PlayerQuestion.berechne_richtung_Koordinate(ich_jetzt.x, ich_jetzt.y, zielx, ziely), 8);
                    jetzt = my_PlayerQuestion.wait_for_new_WM(jetzt);
                    ich_jetzt = (WorldModelElement)jetzt.getFirst();
                    }
                    }
                */
                abstand_test_last = abstand_test;
                System.out.println("    ***** Abstand ist: " + abstand_test);

                lauf_zu_position_relativ(ich_jetzt.x, ich_jetzt.y, zielx, ziely, intense);


            }
        while (abstand_test > abstand);// bin ich eh schon nah am ziel?
        System.out.println(" _ ");
        System.out.println("##     ######## BIN AM ZIEL!!! #########     ##: "+ zielx +"/" + ziely);
        System.out.println(" _ ");
    }

    /**
     * lsst den Spieler in einer Schleife zur angegebenen Koordinate laufen
     * und verlangsamt seine Bewegung, je nher er am Ziel ist
     * @param zielx die x koordinate des Zielpunkts
     * @param ziely die y koordinate des Zielpunkts
     * @param intense so schnell luft der spieler da hin
     * @param abstand wenn er so nah am Ziel ist, hrt er auf
     */
    public void lauf_zu_position_exakt(double zielx, double ziely, double abstand, WorldModelElement ich)
    {
        double abstand_test = 0;
        double abstand_test_last = 1000;


        ich_jetzt = ich;

        abstand_test = my_PlayerQuestion.AbstandKoordinate(ich_jetzt.x, ich_jetzt.y, zielx, ziely);

        while (abstand_test > abstand)// bin ich eh schon nah am ziel?
	      {

                if (!my_PlayerQuestion.bin_ich_auf_kurs(my_PlayerQuestion.berechne_richtung_Koordinate(ich_jetzt.x, ich_jetzt.y, zielx, ziely), 2))
                    {
                        schau_nach_ziel(my_PlayerQuestion.berechne_richtung_Koordinate(ich_jetzt.x, ich_jetzt.y, zielx, ziely), 3);
                    }

                abstand_test = my_PlayerQuestion.AbstandKoordinate(ich_jetzt.x, ich_jetzt.y, zielx, ziely);
                if (abstand_test > 9)
                {
                  lauf_zu_position_relativ(ich_jetzt.x, ich_jetzt.y, zielx, ziely, 100);
                }
                else
                {// die krasse annherungsverlangsamung einsetzen
                lauf_zu_position_relativ(ich_jetzt.x, ich_jetzt.y, zielx, ziely, exaktheit[((int)Math.ceil(abstand_test))]);
                }

                System.out.println("    ***** Abstand ist: " + abstand_test);



            jetzt = my_PlayerQuestion.weltmodell.getT0();
            ich_jetzt = (WorldModelElement)jetzt.getFirst();
        }
        
        System.out.println(" _ ");
        System.out.println("##     ######## BIN AM ZIEL!!! #########     ##: "+ zielx +"/" + ziely+ "und noch so weit weg: " +abstand_test);
        System.out.println(" _ ");
    }



    


    /**
     * findet raus, wie sich er spieler drehen muss, um zu einem Punkt zu gelagen
     * und veranlasst die Drehung; gefolgt von einem dash in diese Richtung
     * @param intense so schnell soll der spieler laufen
     * @param ichx eigene x koordinate
     * @param ichy eigene y koordinate
     * @param zielx x koordinate des zieles
     * @param ziely y koordinate des zieles
     */
    public void lauf_zu_position_relativ(double ichx, double ichy, double zielx, double ziely, int intense)
    {
	//stell_dich_auf_feld();

    //this.warte_auf_timestamp();
	  this.turn_relative(my_PlayerQuestion.berechne_richtung_Koordinate(ichx, ichy, zielx, ziely));

  	this.dash(intense);
  //System.out.println("lauf zu pos relativ!");
    }


     public void lauf_zu_position_relativ_exakt(double ichx, double ichy, double zielx, double ziely)
    {
      double abstand_test = my_PlayerQuestion.AbstandKoordinate(ichx, ichy, zielx, ziely);
      this.turn_relative(my_PlayerQuestion.berechne_richtung_Koordinate(ichx, ichy, zielx, ziely));

      if (abstand_test >= 10)
      {
        this.dash(100);
      }
      else
      {// die krasse annherungsverlangsamung einsetzen
         this.dash(exaktheit[(int)(Math.ceil(abstand_test)-1)]);
      }
      //System.out.println("lauf zu pos relativ exakt!");
    }

     public void lauf_zu_position_relativ_exakt(double ichx, double ichy, double zielx, double ziely, double abstand)
    {

      this.turn_relative(my_PlayerQuestion.berechne_richtung_Koordinate(ichx, ichy, zielx, ziely));

      if (abstand >= 10)
      {
        this.dash(100);
      }
      else
      {// die krasse annherungsverlangsamung einsetzen
         this.dash(exaktheit[(int)(Math.ceil(abstand)-1)]);
      }
      //System.out.println("lauf zu pos relativ exakt!");
    }

    /**
     * dreht sich um 90 grad nach
     * - links, wenn spieler in rechter Spielhlfte steht
     * - rechts, wenn spieler in linker Spielhlfte steht
     @param  ichx  Gib die Koordinaten an. daraus lsst sich erkennen auf welcher seite der spieler steht.
     z.B wegen abseits
    */
    
    /**
     * sorgt dafr, dass der spieler nicht eher ruhe gibt, bis er den ball gefunden hat
     * whrend der schleife wird der spieler langsam zu seiner Homepos bewegt und schaut sich stndig um
     *
     * @prarm intense gibt an, wie schnell der spieler in richtung seiner Homepos laufen soll
     * @return wenn der ball gefunden wurde, wird er bergeben
     */

    public WorldModelElement suche_ball()
    {
	
	    System.out.println("suche Ball");
    	WorldModelElement ball_gefunden = null;
    	LinkedList jetzt = my_PlayerQuestion.weltmodell.getT0();
    	ball_gefunden = my_PlayerQuestion.seh_ich_ball(jetzt);
    	if (ball_gefunden != null)
	    {
    		System.out.println("Ball gefunden");
		    return ball_gefunden;
	    }

      this.change_view(2,1);
    	do
      {
        
    		//this.lauf_zu_homepos(intense, (0.5*my_PlayerQuestion.Abstand_ich_Koordinate(my_PlayerQuestion.homeposx, my_PlayerQuestion.homeposy)));
    		jetzt = my_PlayerQuestion.wait_for_new_WM(jetzt);
    		ball_gefunden = my_PlayerQuestion.seh_ich_ball(jetzt);
        this.turn_absolute(35);
	    }
    	while (ball_gefunden == null);

      this.change_view(1,1);
  	  System.out.println("Ball gefunden");
  	  return ball_gefunden;
    }


      public WorldModelElement suche_ball(LinkedList jetzt)
    {

	    System.out.println("suche Ball");
    	WorldModelElement ball_gefunden = null;
      ball_gefunden = my_PlayerQuestion.seh_ich_ball(jetzt);
    	if (ball_gefunden != null)
	    {
    		System.out.println("Ball gefunden");
		    return ball_gefunden;
	    }

      this.change_view(2,1);
    	do
      {

		    this.turn_absolute(55);
        //this.warte_auf_timestamp();
        //jetzt  = my_PlayerQuestion.weltmodell.getT0();
    		//jetzt = my_PlayerQuestion.wait_for_new_WM(jetzt);// sinnvoll, da dann der turn gemacht is und ein neues WM da ist
    		ball_gefunden = my_PlayerQuestion.seh_ich_ball();
        System.out.println("bin am ball suchen");
	    }
    	while (ball_gefunden == null);

      this.change_view(1,1);
  	  System.out.println("Ball gefunden");
  	  return ball_gefunden;
    }



    public WorldModelElement suche_ball(LinkedList jetzt, WorldModelElement bekannt)
    {

	    System.out.println("suche Ball, kenne bekannten");
    	WorldModelElement ball_gefunden = null;
      ball_gefunden = my_PlayerQuestion.seh_ich_ball(jetzt);
      // seh ich den ball einfach so?
    	if (ball_gefunden != null)
	    {
    		System.out.println("Ball gefunden");
		    return ball_gefunden;
	    }

      this.change_view(2,1);
      // zweiter versuch: ist der ball noch ca. dort, wo ich ihn als letztes gesehen hab?
      if (bekannt.dir != Double.NaN)
      {
        this.turn_relative(bekannt.dir);
        jetzt = my_PlayerQuestion.wait_for_new_WM(jetzt);
        ball_gefunden = my_PlayerQuestion.seh_ich_ball(jetzt);

        if (ball_gefunden != null)
	      {
    		  System.out.println("Ball gefunden");
          this.change_view(1,1);
	  	    return ball_gefunden;
	      }
      }


      // immer noch nix gefunden, also rundrum drehen und suchen
      do
      {
		    this.turn_absolute(55);
        
        jetzt = my_PlayerQuestion.wait_for_new_WM(jetzt);
    		ball_gefunden = my_PlayerQuestion.seh_ich_ball(jetzt);
        System.out.println("bin am ball suchen");
	    }
    	while (ball_gefunden == null);

      this.change_view(1,1);
  	  System.out.println("Ball gefunden");
  	  return ball_gefunden;
    }


    /**
     * Spieler schiet auf das (gegn) Tor. Vorraussetzung: Spieler is in Ballbesitz
     *
     * @param  ichx  Gib die Koordinaten an. holt aus den Koordinaten die Torangaben und rechnet auch
     * ichx und ichy den Schusswinkel aus, aus der dist(ich, tor) die intese
     *
     */
    public void schiess_auf_tor()
    {

	    WorldModelElement ich_jetzt = my_PlayerQuestion.get_ich_jetzt();
      double winkel_zum_tor = my_PlayerQuestion.berechne_richtung_Koordinate(ich_jetzt.x, ich_jetzt.y, 52.2, 0);
      double drehwinkel = my_PlayerQuestion.berechne_drehwinkel(winkel_zum_tor, ich_jetzt);

  	  if(my_PlayerQuestion.gradabweichung(winkel_zum_tor, ich_jetzt.dir) > 45)
	    {

	      this.schau_nach_ziel(winkel_zum_tor, 2);

    	  kick(100, 0);
        System.out.println("kick zum tor nach vorheriger drehung");
  	  }
	    else
	    {
	      System.out.println("Torschuss mit: winkel zum Tor "+(int)winkel_zum_tor+" meine dir "+(int)ich_jetzt.dir+ "kickwinkel: " + my_PlayerQuestion.berechne_drehwinkel(winkel_zum_tor, ich_jetzt));

        if (drehwinkel < 0)
        {
          kick(100, drehwinkel);
        }
        else
        {
        kick(100, drehwinkel);}
	    }


    }// methodenende


    public void schiess_auf_tor_schnell()
    {

	    WorldModelElement ich_jetzt = my_PlayerQuestion.get_ich_jetzt();
      double winkel_zum_tor = my_PlayerQuestion.berechne_richtung_Koordinate(ich_jetzt.x, ich_jetzt.y, 52.2, 0);
      double drehwinkel = my_PlayerQuestion.berechne_drehwinkel(winkel_zum_tor, ich_jetzt);


        kick(100, drehwinkel);
    }// methodenende




    public void schiess_auf_tor_sicher()
    {

	    WorldModelElement ich_jetzt = my_PlayerQuestion.get_ich_jetzt();
      double winkel_zum_tor = my_PlayerQuestion.berechne_richtung_Koordinate(ich_jetzt.x, ich_jetzt.y, 52.2, 0);
      double drehwinkel = my_PlayerQuestion.berechne_drehwinkel(winkel_zum_tor, ich_jetzt);

      if (Math.abs(winkel_zum_tor) < 20 && Math.abs(ich_jetzt.y) > 8)
      {// winkel zum tor zu ungnstig, versuche richtung 11 meterpunkt zu dribbeln
        //this.dribbling(41, 0, 75, ich_jetzt);
        this.turn_relative(my_PlayerQuestion.berechne_richtung_Koordinate(ich_jetzt.x, ich_jetzt.y, 41, 0), ich_jetzt);

        kick(20, 0);
        this.fange_ball_ab(0.8, 2, null);
      }
      else
      {
    	  if(my_PlayerQuestion.gradabweichung(winkel_zum_tor, ich_jetzt.dir) > 45)
	      {

	        this.schau_nach_ziel(winkel_zum_tor, 2);

      	  kick(100, 0);
          System.out.println("kick zum tor nach vorheriger drehung");
  	    }
	      else
  	    {
	        System.out.println("Torschuss mit: winkel zum Tor "+(int)winkel_zum_tor+" meine dir "+(int)ich_jetzt.dir+ "kickwinkel: " + my_PlayerQuestion.berechne_drehwinkel(winkel_zum_tor, ich_jetzt));

          if (drehwinkel < 0)
          {
            kick(100, drehwinkel+8);
          }
          else
          {
            kick(100, drehwinkel-8);}
    	    }

       }
    }







    public void kick_n_rush()
    {
  	  double winkel_zum_tor = 0;
  	  WorldModelElement ich_jetzt = my_PlayerQuestion.get_ich_jetzt();
	    winkel_zum_tor = my_PlayerQuestion.berechne_richtung_Koordinate(ich_jetzt.x, ich_jetzt.y, 52.2, 0);


  	  turn_relative(winkel_zum_tor, ich_jetzt);
      //this.warte_auf_timestamp(); //reinmachen, wenn er sich nicht richitg aufs tor gedreht hat...
	    this.schiess_auf_tor();
      System.out.println("winkel zum Tor "+winkel_zum_tor+" dir "+ich_jetzt.dir);


    }




    /**
     *spieler passt den ball
     *@param  ichx  Gib die Koordinaten an.x Wert
     @param  ichy  Gib die Koordinaten an. y Wert
     @param  zielx  Gib die Koordinaten an. x Wert
     @param  ziely  Gib die Koordinaten an. y Wert
     @param  ichx  Abstand in %. zum nchsten Spieler
    */
    public void spiele_pass_koordinate(double ichx, double ichy, double zielx, double ziely, int intense)
    {




    }

    /**
     * Spieler rennt zu eigenem Tor.
     * @param intense wie schnell der Spieler hinluft
     * @param abstand wie nah der Spieler hinluft, bevor er stehen bleibt
     */
    public void lauf_zu_eig_tor(int intense, double abstand)
    {
    	lauf_zu_position(-52.5, 0, intense, abstand);

    }


    /**
     * Spieler rennt zu generischem Tor.
     * @param intense wie schnell der Spieler hinluft
     * @param abstand wie nah der Spieler hinluft, bevor er stehen bleibt
     */
    public void lauf_zu_geg_tor(int intense, double abstand)
    {
	lauf_zu_position(52.5, 0, intense, abstand);
    }

    /**
     * Spieler rennt zu seiner Homepos
     * @param intense wie schnell der Spieler hinluft
     * @param abstand wie nah der Spieler hinluft, bevor er stehen bleibt
     */
    public void lauf_zu_homepos(int intense, double abstand)
    {
	lauf_zu_position(my_PlayerQuestion.homeposx, my_PlayerQuestion.homeposy, intense, abstand);
    }


    /**
     * Spieler rennt in Richtung seiner Homepos
     * @param intense wie schnell der Spieler hinluft
     */
    public void lauf_richtung_homepos(int intense, WorldModelElement ich)
    {
      lauf_zu_position_relativ(ich.x, ich.y, my_PlayerQuestion.homeposx, my_PlayerQuestion.homeposy, intense);
    }


    public void guck_zu_gegn_tor(WorldModelElement ich)
    {
    turn_relative(my_PlayerQuestion.berechne_richtung_Koordinate(ich.x, ich.y, 52, 0), ich);

    }
    /**
     * nimmt das erste Element von t0 (also "ich") und schaut,
     * ob in x und y was eingetragen ist; unterscheidet 3 Flle:
     * x = nan + y = nan => Spieler sieht keine Linie
     * x = nan + y = 0 => Spieler sieht zwei Linien
     * x != nan => Spieler kennt Position und steht auch aufm Feld
     *
     */
    public void stell_dich_auf_feld()
    {
      jetzt = my_PlayerQuestion.weltmodell.getT0();
      if (jetzt.size()!=0)
      {

        ich_jetzt = my_PlayerQuestion.get_ich_jetzt(jetzt);
        if (Double.isNaN(ich_jetzt.x))
        {// spieler rafft gar nix mehr, 120 drehen + kurz mal dash 100 machen
          do
          {
            System.out.println("turn and dash");
            my_parser.waitForTimestamp();
            turn_absolute(120);
            my_parser.waitForTimestamp();
            dash(100);
            my_parser.waitForTimestamp();
            jetzt = my_PlayerQuestion.wait_for_new_WM(jetzt);
            ich_jetzt = my_PlayerQuestion.get_ich_jetzt(jetzt);
          }
          while (Double.isNaN(ich_jetzt.x));
        }
        else
        { // steh ich aufm Feld?
        // wenn der spieler es nicht schaffen sollte, durch die unten angegebenen bewegungen wieder aufs Feld zu kommen
        // dann ist das nicht wirklich schlimm, davon ausgehend, er bekommt sehr bald richtige Befehle, damit er auf Koordinaten
        // auf dem Feld luft
        boolean andere_koordinate_auch_ok = false;
        // zuerst mal die y koordinate prfen, denn die abweichung kommt vermutlich hufiger vor, als wie hinterm tor zu stehen
          if (ich_jetzt.y > 34)
          {// ich bin oberhalb des feldes
          this.turn_relative(my_PlayerQuestion.berechne_richtung_Koordinate(ich_jetzt.x, ich_jetzt.y, ich_jetzt.x, (ich_jetzt.y-50)), ich_jetzt);
          dash(85);
            jetzt = my_PlayerQuestion.wait_for_new_WM(jetzt);
            ich_jetzt = my_PlayerQuestion.get_ich_jetzt(jetzt);
            if (ich_jetzt.x > 52.5)
            {//ich bin hinter der gegn Torlinie
              this.turn_relative(my_PlayerQuestion.berechne_richtung_Koordinate(ich_jetzt.x, ich_jetzt.y, (ich_jetzt.x-100), ich_jetzt.y), ich_jetzt);
              dash(85);
              andere_koordinate_auch_ok = true;
            }
            else
            {
              if (ich_jetzt.x < -52.5)
              {//ich bin hinter der eig Torlinie
              this.turn_relative(my_PlayerQuestion.berechne_richtung_Koordinate(ich_jetzt.x, ich_jetzt.y, ich_jetzt.x+100, ich_jetzt.y), ich_jetzt);
              dash(85);
              andere_koordinate_auch_ok = true;
              }
            }
          }
          else
          {
            if (ich_jetzt.y < -34)
            {System.out.println("//ich bin oberhalb des feldes");
              this.turn_relative(my_PlayerQuestion.berechne_richtung_Koordinate(ich_jetzt.x, ich_jetzt.y, ich_jetzt.x, ich_jetzt.y+50), ich_jetzt);
              dash(85);
              this.warte_auf_timestamp();
              jetzt = my_PlayerQuestion.wait_for_new_WM(jetzt);
              ich_jetzt = my_PlayerQuestion.get_ich_jetzt(jetzt);
              if (ich_jetzt.x > 52.5)
              { // ich bin hinter der gegn Torlinie
                this.turn_relative(my_PlayerQuestion.berechne_richtung_Koordinate(ich_jetzt.x, ich_jetzt.y, ich_jetzt.x-100, ich_jetzt.y), ich_jetzt);
                dash(85);
                andere_koordinate_auch_ok = true;
              }
              else
              {
                if (ich_jetzt.x < -52.5)
                {//ich bin hinter der eig Torlinie
                  this.turn_relative(my_PlayerQuestion.berechne_richtung_Koordinate(ich_jetzt.x, ich_jetzt.y, ich_jetzt.x+100, ich_jetzt.y), ich_jetzt);
                  dash(85);
                  andere_koordinate_auch_ok = true;
                }
              }
            }

          }

        // nur des noch machen, wenn net schon eben die x koordinate korrigiert wurde
        if (!andere_koordinate_auch_ok)
        {
        if (ich_jetzt.x > 52.5)
        {// ich bin hinter der gegn Torlinie
          this.turn_relative(my_PlayerQuestion.berechne_richtung_Koordinate(ich_jetzt.x, ich_jetzt.y, (ich_jetzt.x - 100), ich_jetzt.y), ich_jetzt);
          dash(85);
            jetzt = my_PlayerQuestion.wait_for_new_WM(jetzt);
            ich_jetzt = my_PlayerQuestion.get_ich_jetzt(jetzt);
            if (ich_jetzt.y > 34)
            {//ich bin oberhalb des feldes
              this.turn_relative(my_PlayerQuestion.berechne_richtung_Koordinate(ich_jetzt.x, ich_jetzt.y, ich_jetzt.x, ich_jetzt.y-50), ich_jetzt);
              dash(85);
            }
            else
            {
              if (ich_jetzt.y < -34)
              {//ich bin unterhalb des feldes
              this.turn_relative(my_PlayerQuestion.berechne_richtung_Koordinate(ich_jetzt.x, ich_jetzt.y, ich_jetzt.x, ich_jetzt.y+50), ich_jetzt);
              dash(85);

              }
            }
        }
        else
        {
            if (ich_jetzt.x < -52.5)
            {// ich bin hinter der eigenen Torlinie
              this.turn_relative(my_PlayerQuestion.berechne_richtung_Koordinate(ich_jetzt.x, ich_jetzt.y, (ich_jetzt.x + 100), ich_jetzt.y), ich_jetzt);
              dash(85);
              jetzt = my_PlayerQuestion.wait_for_new_WM(jetzt);
              ich_jetzt = my_PlayerQuestion.get_ich_jetzt(jetzt);
              if (ich_jetzt.y > 34)
              {//ich bin oberhalb des feldes
                this.turn_relative(my_PlayerQuestion.berechne_richtung_Koordinate(ich_jetzt.x, ich_jetzt.y, ich_jetzt.x, ich_jetzt.y-50), ich_jetzt);
                dash(85);
              }
              else
              {
                if (ich_jetzt.y < -34)
                {//ich bin unterhalb des feldes
                  this.turn_relative(my_PlayerQuestion.berechne_richtung_Koordinate(ich_jetzt.x, ich_jetzt.y, ich_jetzt.x, ich_jetzt.y+50), ich_jetzt);
                  dash(85);

                }
              }
            }

          }

        }
        }
      }

  }// methodenende

    /**
     * sorgt dafr, dass der Spieler nicht eher in Ruhe gelassen wird,
     * bis er in eine angegebenen Richtung (abzglich toleranz) schaut.
     * @param ziel da sol der spieler hingucken
     * @toleranz Toleranzspielraum fr den richtigen Winkel
     *
     */
    public void schau_nach_ziel(double ziel, double toleranz)
    {
	LinkedList temp;
        System.out.println("schau nach Ziel: " + ziel);
        jetzt = my_PlayerQuestion.weltmodell.getT0();
        do
            {


                my_parser.waitForTimestamp();
                turn_relative(ziel);
                jetzt = my_PlayerQuestion.wait_for_new_WM(jetzt);

                ich_jetzt = (WorldModelElement)jetzt.getFirst();
                System.out.println("abweichung ist: " +(ich_jetzt.dir -ziel) + "Gradabweichung ist: " + my_PlayerQuestion.gradabweichung(ich_jetzt.dir,ziel));

            }
        while (my_PlayerQuestion.gradabweichung(ich_jetzt.dir,ziel) > toleranz);

    }

    /**
     * der Spieler mussin ballbesitz sein und dribblet dann zur angegebenen Koordinate
     * @param zielx X Koordinate des Ziels
     * @param zielx X Koordinate des Ziels
     * @param abstand so nah geht der spieler bis ans Ziel dran
     */
    public void dribbling(double zielx, double ziely, int intense, LinkedList jetzt)
    {
      WorldModelElement ich = my_PlayerQuestion.get_ich_jetzt(jetzt);

      this.turn_relative(my_PlayerQuestion.berechne_richtung_Koordinate(ich.x, ich.y, zielx, ziely));
      this.warte_auf_timestamp();
      this.kick(30, 0);
      //jetzt = my_PlayerQuestion.weltmodell.getT0();
      //WorldModelElement ball = my_PlayerQuestion.get_ball_jetzt(jetzt);
      //this.fange_ball_ab(1, 2, ball);
      //System.out.println("ich: " + (int)ich.x + "/" + (int)ich.y + "drehwinkel: " + (int)my_PlayerQuestion.berechne_richtung_Koordinate(ich.x, ich.y, zielx, ziely));
    }


    public void warte_auf_timestamp()
    {
	my_parser.waitForTimestamp();
    }



    /**
     * sorgt in einer Schleife dafr, dass der Spieler nicht mehr im Abseits steht.
     *
     */
  public WorldModelElement raus_ausm_abseits_loop()
  {

	//this.warte_auf_timestamp();
  WorldModelElement temp = null;
  jetzt= my_PlayerQuestion.weltmodell.getT0();
	ball_jetzt = my_PlayerQuestion.get_ball_jetzt(jetzt);
	ich_jetzt = my_PlayerQuestion.get_ich_jetzt(jetzt);


	if (ball_jetzt == null)
  {// keine checkung, wo der ball is
		if (ich_jetzt.x > 0 )
    {
			System.out.print("oh, ich bin in der Feindhaelfte, aber der ball is weg");
			// laufe n stck zur homepos, keinen Loop machen, da es nicht klar ist, ob abseitsgefahr besteht
			this.warte_auf_timestamp();
			this.lauf_zu_position_relativ(ich_jetzt.x, ich_jetzt.y, my_PlayerQuestion.homeposx, my_PlayerQuestion.homeposx, 100);
      return temp;

    }
		else
    {
			System.out.print("zum gegn Tor gucken, weil ball unbekannt und nicht in feindhaelfte");

     // this.guck_zu_gegn_tor(ich_jetzt);
      return temp;
			//WorldModelElement temp = suche_ball(100);

    }
	}
	else
	{// ich weiss, wo der ball is
		if (ich_jetzt.x > 0)
    {// bin in der feindhlfte
			System.out.print("oh, ich bin in der Feindhaelfte, und  der ball ist da");
      double ball_alt = ball_jetzt.x;
      jetzt = my_PlayerQuestion.wait_for_new_WM(jetzt);
//      ball_jetzt = this.suche_ball();

      ich_jetzt = my_PlayerQuestion.get_ich_jetzt(jetzt);
      double delta_x = ich_jetzt.x-ball_alt;
			if (delta_x > 0)
      {
				// ich bin abseitsgefhrdet, halte deine hhe und lauf zur eig Hlfte

				do
        {
          //this.warte_auf_timestamp();
					this.lauf_zu_position_relativ(ich_jetzt.x, ich_jetzt.y, ((ich_jetzt.x-delta_x)-4), ich_jetzt.y,100);


          jetzt = my_PlayerQuestion.weltmodell.getT0();
          ich_jetzt = my_PlayerQuestion.get_ich_jetzt(jetzt);
          ball_jetzt = my_PlayerQuestion.get_ball_jetzt(jetzt);

          if (ball_jetzt == null)
          {
            delta_x = ich_jetzt.x-ball_alt;
          }
          else
          {
            delta_x = ich_jetzt.x-ball_jetzt.x;
          }

          //System.out.print("entkomme Abseits,noch zu laufen: " + (int)delta_x + "ich x: " + (int)ich_jetzt.x + "Ball x: " + (int)ball_jetzt.x);

        }
				while (delta_x > 0 && ich_jetzt.x > 0);
        return ball_jetzt;
      }
      else
      {
        System.out.print("bin zwar in der feindhflte, aber net im abseits");
        return ball_jetzt;
      }
    }
    else
    {// bin nicht in der feindhlfte
      return ball_jetzt;
    }
  }
	

  }



    public void fange_ball_ab(double abstand, int zyklen, WorldModelElement ball_bekannt)
    {
      //raus_ausm_abseits_loop();
      ball_jetzt= ball_bekannt;
      jetzt = my_PlayerQuestion.weltmodell.getT0();
      ich_jetzt =  my_PlayerQuestion.get_ich_jetzt();
      ballPos = my_PlayerQuestion.wohin_rollt_ball();

      if (ballPos[0] == Double.NaN)
      {
        ball_jetzt = this.suche_ball(jetzt, ball_bekannt);
        ballPos[0] = ball_jetzt.x;
        ballPos[1] = ball_jetzt.y;
      }
      double testabstand = my_PlayerQuestion.AbstandKoordinate(ich_jetzt.x, ich_jetzt.y, ballPos[0], ballPos[1]);
      System.out.println("fang ball ab, bin so weit weg: " +(int)testabstand + "und muss so nah dran: " + abstand);

      ich_jetzt =  my_PlayerQuestion.get_ich_jetzt();
      for (int i = 0; i < zyklen; i++)
      {



        ballPos = my_PlayerQuestion.wohin_rollt_ball();
        if (testabstand == Double.NaN || testabstand < 2)
        {// also konnt ich nicht ermitteln, wo der ball hinrollen wird, oder aber ich bin schon nher wie 2 einheiten dran
          // jetzt mit genauen Ball werten arbeiten
          ball_jetzt = this.suche_ball(jetzt, ball_jetzt);
          ballPos[0] = ball_jetzt.x;
          ballPos[1] = ball_jetzt.y;
        }

        this.lauf_zu_position_relativ_exakt(ich_jetzt.x, ich_jetzt.y,ballPos[0], ballPos[1], testabstand);
      //  this.warte_auf_timestamp();
        ich_jetzt =  my_PlayerQuestion.get_ich_jetzt();
        testabstand = my_PlayerQuestion.AbstandKoordinate(ich_jetzt.x, ich_jetzt.y, ballPos[0], ballPos[1]);
        //if (testabstand >= abstand){i = zyklen;}// dann is gut, bi nnah genug dran
        if (testabstand >= abstand){break;}// dann is gut, bi nnah genug dran
      }

    }



    public void tormann_catch_it(WorldModelElement ball_bekannt, WorldModelElement ich, double[] ballPos, double ball_dist)
    {
      double ball_winkel = my_PlayerQuestion.berechne_richtung_Koordinate(ich.x, ich.y, ballPos[0], ballPos[1]);

      do
      {
        turn_relative(ball_winkel, ich);

        

        if (my_PlayerQuestion.Abstand_ich_Koordinate(ballPos[0], ballPos[1], ich) <= 1);
        {
          this.catch_it(my_PlayerQuestion.berechne_drehwinkel(ball_winkel, ich));
        }

        fange_ball_ab( 1, 1, ball_bekannt);
        jetzt = my_PlayerQuestion.weltmodell.getT0();
        ich = my_PlayerQuestion.get_ich_jetzt(jetzt);
        ballPos = my_PlayerQuestion.wohin_rollt_ball();
        ball_bekannt = this.suche_ball(jetzt, ball_bekannt);
        ball_winkel = my_PlayerQuestion.berechne_richtung_Koordinate(ich.x, ich.y, ballPos[0], ballPos[1]);
      }
      while (my_PlayerQuestion.Spielmodus == 3);// solang play_on ist

      this.guck_zu_gegn_tor(ich);
      this.schiess_auf_tor();

    }


    public void move_nach_eigenem_tor(int homey)
    {
        System.out.println("switch zum beamen ist bei: " + homey);
        switch (homey)
          {
            case -10:
            {
              System.out.println("switch matchcase! " + homey);
              this.move(-10, 3);
              break;
            }

            case 10:
            {
              System.out.println("switch matchcase! " + homey);
              this.move(-10, 2);
              break;
            }

            case -8:
            {
              System.out.println("switch matchcase! " + homey);
              this.move(-10, 1);
              break;
            }

            case -0:
            {
              System.out.println("switch matchcase! " + homey);
              this.move(-10, 0);
              break;
            }

            case 8:
            {
              this.move(-10, -1);
              break;
            }

            case -5:
            {
              this.move(-10, -2);
              break;
            }

            case 5:
            {
              this.move(-10, -3);
              break;
            }
          }
     }


     public void move_nach_gegentor(int home_x, int home_y)
     {
     this.move(home_x, home_y);

     }
}// klassenende!












