// doc fertig

import java.util.*;
/**

Das ist der Parser.Er analysiert eingehende nachrichten und gibt sie dann 
aufbereitet in verkettete listen an Weltmodell und Strategie weiter.

@author Hco, Jvrg
@version 2.8 final (SE)
*/


public class Parser extends Thread
{
    CommunicationChannel comChannel;
    Strategy strategie;
    WorldModel WeltBild;
    
    //Fuer Weltbild
    /** 
	Die enthdlt Positionen von Spielern und Ball (bewegliche Objekte)
    */
    public LinkedList dynListe = new LinkedList();		
    /** 
	Enthdlt alle festen Objekte. Tore,Flaggen, Linien
    */
    public LinkedList statListe = new LinkedList();
    
    //Sense_body-Kram
    String[] viewmode={ "", "" };
    double[] stamina={ 0, 0 };
    double[] speed={ 0, 0 };
    double headAngle=0;
    int kickCount=0;
    int dashCount=0;
    int turnCount=0;
    int sayCount=0;
    int turn_neckCount=0;
    int catchCount=0;
    int moveCount=0;
    int changeViewCount=0;
    /**
       Entnimmt den Nachrichten die Zeit.
       Zur Feststellung wie alt die Nachricht ist
       @param time  =  zeitstempel z.b. 312 (integer wert)
       @param rest  =  zdhlt die anzahl der Eintrdge (tokens)
    */
    public int time;
    private int rest;

    // Fuer "hear"
    String heardMsg;
    // 0=undef, 1=Winkel, 2=self, 3=referee
    int whoIsTalking=0;
    double woher=Double.NaN;
    
    Parser(CommunicationChannel comChannel)
    {
	this.comChannel=comChannel;
    }
    
    Parser(Player ich)
    {
	this.comChannel=ich.Netz;
	this.strategie=ich.Strategie;
	this.WeltBild=ich.WeltBild;
    }

    public void waitForTimestamp()    
    {
	int oldTime=time;
	do
	    {
		try { sleep(10); }
		catch (Exception e) {}
	    }
	while (time==oldTime);
    }
    /** 
	??????????????????????????  fliegt vielleicht noch raus ??????????
	@param Strategy
	@param strate
    */
    public void addStrategy(Strategy strate)
    {
	this. strategie=strate;
    }

    /**
       Das ist eine super methode.	Sie zerst|ckelt den eingehenden String, schneidet alle Leerzeichen und 
       Klamern aus und speichert es in die daf|r vorgesehenen Listen. selbsterkldrend
    */
    public void run()
    {
	    
	WorldModelElement anfang;
	String msg;   
	    
	String temp;
	//String temp2;

	boolean newData=false;
	    
	while (true) {
	    msg=comChannel.receive();
		
	    StringTokenizer tokenizer = new StringTokenizer(msg, "()");
	    StringTokenizer mini_tokenizer;
		
	    if (msg.startsWith("(see")) {
		dynListe = new LinkedList();   
		statListe = new LinkedList();

		// z.B. see 0
		rest=tokenizer.countTokens()-1;

		try {

		    time = Integer.parseInt(tokenizer.nextToken().substring(4).trim());
		}
		catch (Exception e) { System.out.println("Parser: time kaputt "+msg); }

		while (rest>=2)
		    {
			
			anfang=new WorldModelElement();
			try {
			    //name
			    anfang.name=tokenizer.nextToken();
			    //Infos
			    mini_tokenizer=new StringTokenizer(tokenizer.nextToken());
			    switch (mini_tokenizer.countTokens())
				{
				case 1: {
				    anfang.dir=Double.parseDouble(mini_tokenizer.nextToken());
				    break;
				}
				case 2: {
				    anfang.dist=Double.parseDouble(mini_tokenizer.nextToken());
				    anfang.dir=Double.parseDouble(mini_tokenizer.nextToken());
				    break;
				}
				case 4: {
				    anfang.dist=Double.parseDouble(mini_tokenizer.nextToken());
				    anfang.dir=Double.parseDouble(mini_tokenizer.nextToken());
				    anfang.distChange=Double.parseDouble(mini_tokenizer.nextToken());
				    anfang.dirChange=Double.parseDouble(mini_tokenizer.nextToken());
				    break;
				}
				case 6: {
				    anfang.dist=Double.parseDouble(mini_tokenizer.nextToken());
				    anfang.dir=Double.parseDouble(mini_tokenizer.nextToken());
				    anfang.distChange=Double.parseDouble(mini_tokenizer.nextToken());
				    anfang.dirChange=Double.parseDouble(mini_tokenizer.nextToken());
				    anfang.bodyDir=Double.parseDouble(mini_tokenizer.nextToken());
				    anfang.headDir=Double.parseDouble(mini_tokenizer.nextToken());
				    break;
				}
				}
			}
			catch (Exception e) { System.out.println("Parser: see-Element kaputt? "+msg); }
			try {
			    if ( anfang.name.startsWith( "b" ) ||  anfang.name.startsWith( "B" ) )
			    
				{
				    anfang.isFriend=2;
				    dynListe.add(anfang);
				} else if (anfang.name.startsWith("P"))
				    {
					//anfang.name tokenizen
					dynListe.add(anfang);
				    } else if (anfang.name.startsWith("p"))
					{				    
					    mini_tokenizer=new StringTokenizer(anfang.name);
					    switch (mini_tokenizer.countTokens()) 
						{
						    //p
						case 1: {
						    dynListe.add(anfang);
						    break;
						}
				    
						case 2: {
						    temp=mini_tokenizer.nextToken();
						    temp=mini_tokenizer.nextToken();
						    if (temp.equals("\"ManU\"")) {
							anfang.isFriend=0;
						    } else {
							anfang.isFriend=1;
						    }
						    dynListe.add(anfang);
						    break;
						}
				    
						case 3: {
						    temp=mini_tokenizer.nextToken();
						    temp=mini_tokenizer.nextToken();
						    if (temp.equals("\"ManU\"")) {
							anfang.isFriend=0;
						    } else {
							anfang.isFriend=1;
						    }
						    temp=mini_tokenizer.nextToken();
						    anfang.playerNr=Integer.parseInt(temp); 
						    dynListe.add(anfang);
						    break;
						}
				    
						case 4: {
						    temp=mini_tokenizer.nextToken();
						    temp=mini_tokenizer.nextToken();
						    if (temp.equals("\"ManU\"")) {
							anfang.isFriend=0;
						    } else {
							anfang.isFriend=1;
						    }
						    anfang.playerNr=12;
						    dynListe.add(anfang);
						    break;
						}
				    
						    // evtl. "TeamName"
				    
				    
						    // evtl. UniFormNr
						    // evtl. goalie
						}
					} else {
					    statListe.add(anfang);
					}
			}
			catch (Exception e) { System.out.println("Parser: Ball? Freund? Feind? "+msg); }

						
			    //"leer"
			try {
			    temp=tokenizer.nextToken();
			    rest=rest-3;
			} 
			catch (Exception e) { 
			    System.out.println("Parser: Alternatives Listenende"); 
			    rest=0;
			}
			    // ab hier an Deike....
			    //		Weltbild.giveData(time, gameDir, statListe, dynListe);

			    //debug-output, aber sehr erfreulich :)
			    //System.out.println("gibListen s:"+statListe.size()+" "+" d:"+dynListe.size());
		    }
		try { WeltBild.giveObjectList(time,statListe,dynListe); }
		catch (Exception e) { System.out.println("Parser: Aua, WeltBild mag nich"); }
			
		
	    } else if (msg.startsWith("(hear")) 
		{
		    tokenizer = new StringTokenizer(msg);
		    //"(hear"
		    newData=false;
		    try {
			tokenizer.nextToken();
			//time
			time = Integer.parseInt(tokenizer.nextToken());
			// "referee" oder "self" oder direction
			temp=tokenizer.nextToken();
			if (temp.equals("referee")) {
			    whoIsTalking=3;
			} else if (temp.equals("self")) { 
			    whoIsTalking=2;
			} else {
			    whoIsTalking=1;
			    woher=Double.parseDouble(temp);
			}
			mini_tokenizer=new StringTokenizer(tokenizer.nextToken(),"\"");
			heardMsg=mini_tokenizer.nextToken();
			newData=true;
		    }
		    catch (Exception e) { System.out.println("Parser: kaputte msg erhalten, glaube ich: "+msg); }
		    if (newData) { strategie.take_heard(whoIsTalking, heardMsg, time, woher); }
		    //strategie.take_heard(whoIsTalking, heardMsg, time);

		} else if (msg.startsWith("(sense_body"))
		    {
			try {
			    //z.B. sense_body 0
			    temp=tokenizer.nextToken();
			    mini_tokenizer=new StringTokenizer(temp);
			    mini_tokenizer.nextToken();
			    time=Integer.parseInt(mini_tokenizer.nextToken());

			    //view_mode
			    temp=tokenizer.nextToken();
			    mini_tokenizer=new StringTokenizer(temp);
			    mini_tokenizer.nextToken();
			    viewmode[0]=mini_tokenizer.nextToken();
			    viewmode[1]=mini_tokenizer.nextToken();
			    //leer
			    temp=tokenizer.nextToken();
		    
			    //stamina
			    temp=tokenizer.nextToken();
			    mini_tokenizer=new StringTokenizer(temp);
			    mini_tokenizer.nextToken();
			    stamina[0]=Double.parseDouble(mini_tokenizer.nextToken());
			    stamina[1]=Double.parseDouble(mini_tokenizer.nextToken());
			    //leer 
			    temp=tokenizer.nextToken();
		    
			    //speed
			    temp=tokenizer.nextToken();
			    mini_tokenizer=new StringTokenizer(temp);
			    mini_tokenizer.nextToken();
			    speed[0]=Double.parseDouble(mini_tokenizer.nextToken());
			    speed[1]=Double.parseDouble(mini_tokenizer.nextToken());
			    //leer
			    temp=tokenizer.nextToken();
		    
			    //head_angle
			    temp=tokenizer.nextToken();
			    mini_tokenizer=new StringTokenizer(temp);
			    mini_tokenizer.nextToken();
			    headAngle=Double.parseDouble(mini_tokenizer.nextToken());
			    //leer
			    temp=tokenizer.nextToken();
		    
			    //kick
			    temp=tokenizer.nextToken();
			    mini_tokenizer=new StringTokenizer(temp);
			    mini_tokenizer.nextToken();
			    kickCount=Integer.parseInt(mini_tokenizer.nextToken());
			    //leer
			    temp=tokenizer.nextToken();
		    
			    //dash
			    temp=tokenizer.nextToken();
			    mini_tokenizer=new StringTokenizer(temp);
			    mini_tokenizer.nextToken();
			    dashCount=Integer.parseInt(mini_tokenizer.nextToken());
			    //leer
			    temp=tokenizer.nextToken();
		    
			    //turn
			    temp=tokenizer.nextToken();
			    mini_tokenizer=new StringTokenizer(temp);
			    mini_tokenizer.nextToken();
			    turnCount=Integer.parseInt(mini_tokenizer.nextToken());
			    //leer
			    temp=tokenizer.nextToken();
		    
			    //say
			    temp=tokenizer.nextToken();
			    mini_tokenizer=new StringTokenizer(temp);
			    mini_tokenizer.nextToken();
			    sayCount=Integer.parseInt(mini_tokenizer.nextToken());
			    //leer
			    temp=tokenizer.nextToken();
		    
			    //turn_neck
			    temp=tokenizer.nextToken();
			    mini_tokenizer=new StringTokenizer(temp);
			    mini_tokenizer.nextToken();
			    turn_neckCount=Integer.parseInt(mini_tokenizer.nextToken());
			    //leer
			    temp=tokenizer.nextToken();
		    
			    //catch
			    temp=tokenizer.nextToken();
			    mini_tokenizer=new StringTokenizer(temp);
			    mini_tokenizer.nextToken();
			    catchCount=Integer.parseInt(mini_tokenizer.nextToken());
			    //leer
			    temp=tokenizer.nextToken();
		    
			    //move
			    temp=tokenizer.nextToken();
			    mini_tokenizer=new StringTokenizer(temp);
			    mini_tokenizer.nextToken();
			    moveCount=Integer.parseInt(mini_tokenizer.nextToken());
			    //leer
			    temp=tokenizer.nextToken();
		    
			    //change_view
			    temp=tokenizer.nextToken();
			    mini_tokenizer=new StringTokenizer(temp);
			    mini_tokenizer.nextToken();
			    changeViewCount=Integer.parseInt(mini_tokenizer.nextToken());
			}
			catch (Exception e) { System.out.println("Parser: kaputte msg erhalten, glaube ich: "+msg); }

		    
		    } else if (msg.startsWith("(server_param"))
			{
		    
			} else if (msg.startsWith("(player_param"))
			    {
		    
			    } else if (msg.startsWith("(player_type"))
				{
		    
				}  else if (msg.startsWith("(error"))
				    {
					System.out.println("Parser: Server sagt: "+msg);
				    }
	}
    }
}
