/**
*Enthlt alle erkannten Objekt auf dem Spielfeld
*
*@author hco
*@version 1.8
*/


public class WorldModelElement
{
	/** 
	name des erkannten objektes
	*/
	public String name;
		/** 
	0=Freund 1=Feind 2=Ball 3=Unbekannt/Undef
	*/
	public int isFriend;
	
	/**
	gibt dem spieler eine nummer. 0=nix, 1-11 Spieler, 12 goalie
	*/
	public int playerNr;
	/**
	koordinate x
	*/
	public double x;
	/**
	koordinate y
	*/
	public double y;
	/**
	der winkel zwischen blickrichtung und gesehenem objekt
	*/
	public double dir;
	/**
	Entfernung vom akuellen spieler zum gesehen objekt.
	*/
	public double dist;
	/**
	Entfernung zwischen dem Objekt bei Zeitpunkt  t, t-1
	*/
	public double distChange;
	/**
	nderung des Winkels bei zeitpunkt  t, t-1
	*/
	public double dirChange;
	/**
	gibt die Krperrichtung an
	*/
	public double bodyDir;
	/**
	gibt die blickrichtung zum Krper an
	*/
	public double headDir;
	



	/**WorldModelElement gibt "strategische" Infos aus, die fr den Spielverlauf wichtig sind.
*/
  public WorldModelElement()
    {
	name="";
	isFriend=3;
  	playerNr=0;
	x=Double.NaN;
  	y=Double.NaN;
	dir=Double.NaN;
  	dist=Double.NaN;
	distChange=Double.NaN;
  	dirChange=Double.NaN;
	bodyDir=Double.NaN;
  	headDir=Double.NaN;
  }





}
